/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2008 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: hp.h,v 1.4 2008/03/11 03:25:16 zlb Exp $ */

#ifndef PHG_HP_H
#define PHG_HP_H

struct HP_INFO_ {
    DOF_TYPE	**types;	/* DOF_TYPE* array */
    BYTE	min_order;	/* minimum order */
    BYTE	max_order;	/* maximum order */
};

/* Note: it is assumed at present that the order on the vertices is constant */
struct HP_DATA_ {
    HP_INFO	*info;
    /* lists of orders */
    BYTE	*edge_order;	/* list of basis orders on edges */
    BYTE	*face_order;	/* list of basis orders on faces */
    BYTE	*elem_order;	/* list of basis orders on elements */
    /* indices to DOF data */
    INT		*edge_index;	/* indices of edge DOF data */
    INT		*face_index;	/* indices of face DOF data */
    INT		*elem_index;	/* indices of element DOF data */
    /* global data counts */
    INT		edge_data_count_global;
    INT		face_data_count_global;
    INT		elem_data_count_global;
};

#ifdef __cplusplus
extern "C" {
#endif

void phgHPSetup(DOF *u);

#ifdef __cplusplus
}
#endif

#endif	/* PHG_HP_H */
