/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2008 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: mpi-utils.h,v 1.5 2007/04/06 08:33:08 zlb Exp $ */

#ifndef PHG_MPI_UTILS_H

#ifdef __cplusplus
extern "C" {
#endif

int phgAlltoallv___(
    void *sendbuf, int *sendcnts, int *sdispls, MPI_Datatype sendtype,
    void *recvbuf, int *recvcnts, int *rdispls, MPI_Datatype recvtype,
    MPI_Comm comm, const char *file, int line);
#define phgAlltoallv(sbuf, scnt, sdsp, stype, rbuf, rcnt, rdsp, rtype, comm) \
     phgAlltoallv___(sbuf, scnt, sdsp, stype, rbuf, rcnt, rdsp, rtype, comm, \
		     __FILE__, __LINE__)

int phgAlltoallvBegin(
    void *sendbuf, int *sendcnts, int *sdispls, MPI_Datatype sendtype,
    void *recvbuf, int *recvcnts, int *rdispls, MPI_Datatype recvtype,
    MPI_Comm comm, MPI_Request **reqarray, int *nsends, int *nrecvs);
int phgAlltoallvEnd(int nsends, int nrecvs, MPI_Request **reqarray);

int phgAlltoallvInit(
    void *sendbuf, int *sendcnts, int *sdispls, MPI_Datatype sendtype,
    void *recvbuf, int *recvcnts, int *rdispls, MPI_Datatype recvtype,
    MPI_Comm comm, MPI_Request **reqarray, int *nsends, int *nrecvs);

#ifdef __cplusplus
}
#endif

#define PHG_MPI_UTILS_H
#endif
