/* Parallel Hierarchical Grid -- an adaptive finite element library.
 *
 * Copyright (C) 2005-2008 State Key Laboratory of Scientific and
 * Engineering Computing, Chinese Academy of Sciences. */

/* This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA  02110-1301  USA */

/* $Id: test0.c,v 1.7 2007/01/09 07:49:58 zlb Exp $ */

#include "phg.h"
#include <stdlib.h>
#include <string.h>

int
main(int argc, char *argv[])
{
    GRID *g;

    phgInit(&argc, &argv);

    if (argc != 2) {
	phgPrintf("Usage: %s mesh_file\n", argv[0]);
	phgFinalize();
	exit(1);
    }

    g = phgNewGrid(VERT_FLAG | EDGE_FLAG);
    if (!phgImport(g, argv[1], FALSE))
	phgError(1, "can't read file \"%s\".\n", argv[1]);
    //phgDumpGrid(g);

    phgFreeGrid(&g);
    phgFinalize();
    
    return 0;
}
